#!/bin/bash

PATH_SAVE_DIR=/tmp/savedPaths
mkdir -p $PATH_SAVE_DIR
NECESSITAS_SDK_PATH_FILE=$PATH_SAVE_DIR/necessitasSdkPath
NDK_ROOT_PATH_FILE=$PATH_SAVE_DIR/ndkRootPath
ANDROID_SDK_PATH_FILE=$PATH_SAVE_DIR/androidSdkPath
ANT_BIN_PATH_FILE=$PATH_SAVE_DIR/antBinPath

RUNNING_DIR=$PWD

echo "Please provide NECESSITAS_SDK_PATH !!!"
read NECESSITAS_SDK_PATH
if [ "$NECESSITAS_SDK_PATH" == "" ]; then 
	echo "Please provide NECESSITAS_SDK_PATH !!!"
	exit -1
fi
rm -f $NECESSITAS_SDK_PATH_FILE
echo $NECESSITAS_SDK_PATH > $NECESSITAS_SDK_PATH_FILE


echo "Please provide NDK_ROOT !!!"
read NDK_ROOT
if [ "$NDK_ROOT" == "" ]; then 
	echo "Please provide NDK_ROOT !!!"
	exit -1
fi
rm -f $NDK_ROOT_PATH_FILE
echo $NDK_ROOT > $NDK_ROOT_PATH_FILE

echo "Please provide ANDROID_SDK_PATH !!!"
read ANDROID_SDK_PATH
if [ "$ANDROID_SDK_PATH" == "" ]; then 
	echo "Please provide ANDROID_SDK_PATH !!!"
	exit -1
fi
rm -f $ANDROID_SDK_PATH_FILE
echo $ANDROID_SDK_PATH > $ANDROID_SDK_PATH_FILE

echo "Please provide ANT_BIN_PATH !!!"
read ANT_BIN_PATH
if [ "$ANT_BIN_PATH" == "" ]; then 
	echo "Please provide ANT_PATH !!!"
	exit -1
fi
rm -f $ANT_BIN_PATH_FILE
echo $ANT_BIN_PATH > $ANT_BIN_PATH_FILE


ARM_EABI=armeabi-v7a
ANDROID_NDK_PLATFORM=android-8

QT_CLEAN=0

QT_BUILD_DEBUG=0

QT_BUILD=0				# 0 - don't build qt
						# 1 - Build qt
						
QT_BUILD_OPT=1			# 0 - don't configure qt (only compile) default
						# 1 - configure qt and compile qt

DOWNLOAD_OPENSSL=0

echo -e "NECESSITAS_SDK_PATH : $NECESSITAS_SDK_PATH"
echo -e "ANDROID_NDK_PLATFORM : $ANDROID_NDK_PLATFORM"

echo -e "Installing ortp lib and headers ... "
cp $PWD/libs/ortp/*.so $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/lib
cp -R $PWD/include/ortp/ortp $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/include
echo -e "DONE"

echo -e "Installing android lib..."
cp $PWD/libs/android/*.so $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/lib
echo -e "DONE"

if [ -d $NECESSITAS_SDK_PATH/Android/Qt/480/$ARM_EABI ]
then 
DUMMY="dummy"
else 	
	mkdir -p $NECESSITAS_SDK_PATH/Android/Qt/480/$ARM_EABI
fi

echo -e "Configuring Necessitas SDK ..."
cd $NECESSITAS_SDK_PATH/Android/Qt/480/$ARM_EABI
../qt-src/android/androidconfigbuild.sh -n $NDK_ROOT -d $QT_BUILD_DEBUG -b $QT_BUILD -c $QT_CLEAN -q $QT_BUILD_OPT -a $ARM_EABI -w $DOWNLOAD_OPENSSL -l `echo $ANDROID_NDK_PLATFORM | grep -Po "(?<=android\-).*"`

cd $NECESSITAS_SDK_PATH/Android/Qt/480/$ARM_EABI/qmake
make clean
make

echo -e "Installing qt utils ..."
cp $RUNNING_DIR/bin/* $NECESSITAS_SDK_PATH/Android/Qt/480/$ARM_EABI/bin/

echo -e "DONE"
echo -e "Necessitas SDK ready for compiling the Apps !!"
