#!/bin/bash
PATH_SAVE_DIR=/tmp/savedPaths
NECESSITAS_SDK_PATH_FILE=$PATH_SAVE_DIR/necessitasSdkPath
NDK_ROOT_PATH_FILE=$PATH_SAVE_DIR/ndkRootPath
ANDROID_SDK_PATH_FILE=$PATH_SAVE_DIR/androidSdkPath
ANT_BIN_PATH_FILE=$PATH_SAVE_DIR/antBinPath


if [ -f $NECESSITAS_SDK_PATH_FILE ]
	then
	NECESSITAS_SDK_PATH=$(cat $NECESSITAS_SDK_PATH_FILE)
else 	
	echo "NECESSITAS_SDK_PATH Not Set !!"
	echo "Please run configure_necessitas.sh atleast once on this machine"
	exit -1
fi

if [ -f $NDK_ROOT_PATH_FILE ]
	then
	NDK_ROOT=$(cat $NDK_ROOT_PATH_FILE)
else 	
	echo "NDK_ROOT Not Set !!"
	echo "Please run configure_necessitas.sh atleast once on this machine"
	exit -1
fi

if [ -f $ANDROID_SDK_PATH_FILE ]
	then
	ANDROID_SDK_PATH=$(cat $ANDROID_SDK_PATH_FILE)
else 	
	echo "ANDROID_SDK_PATH Not Set !!"
	echo "Please run configure_necessitas.sh atleast once on this machine"
	exit -1
fi

if [ -f $ANT_BIN_PATH_FILE ]
	then
	ANT_BIN_PATH=$(cat $ANT_BIN_PATH_FILE)
else 	
	echo "ANT_BIN_PATH Not Set !!"
	echo "Please run configure_necessitas.sh atleast once on this machine"
	exit -1
fi


ARM_EABI=armeabi-v7a
ANDROID_NDK_PLATFORM=android-8

echo -e "NECESSITAS_SDK_PATH : $NECESSITAS_SDK_PATH"
echo -e "ANDROID_NDK_PLATFORM : $ANDROID_NDK_PLATFORM"

echo -e "Installing pre-compiled stripped Qt Base libs and headers ..."
cp $PWD/libs/qtBase/*.so $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/lib
rm -rf $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/include/QtCore
rm -rf $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/include/QtNetwork
rm -rf $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/include/QtXml
cp -R $PWD/include/qtBase/QtCore $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/include/
cp -R $PWD/include/qtBase/QtNetwork $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/include/
cp -R $PWD/include/qtBase/QtXml $NDK_ROOT/platforms/$ANDROID_NDK_PLATFORM/arch-arm/usr/include/
echo -e "DONE"

